/*
//        C-51 Demo program for CEIBO 51 Debugger
//             Copyright (c) 1994,6 by CEIBO
//
//        Program compiled with KEIL C-51 compiler
//        Compiler command line : (For Emulator test files: ctest.abs)
//           C51 ctest.c ROM(SMALL) DEBUG OBJECTEXTEND NOAMAKE DF(EMULATOR)
//        Linker command line :
//           L51 ctest.obj,cinit.obj,cdelay.obj TO ctest.abs CODE(100h)
//
//        Compiler command line : (For Simulator test files: ctests.abs)
//           C51 ctest.c ROM(SMALL) DEBUG OBJECTEXTEND NOAMAKE DF(SIMULATOR)
//        Linker command line :
//           L51 ctest.obj,cinit.obj,cdelay.obj TO ctests.abs CODE(100h)
//
*/

/*
//     Global variables definition
*/
unsigned int     DelayCnt;
unsigned int     DelayValue;
unsigned char    PatternROL;
unsigned char    PatternROR;
unsigned char    PatternCPL;

sfr RegP1 = 0x90;


/*
//    External functions declaration
*/
extern void init();
extern void Delay();


/*
//           Function : RolP1
//           ==================
//           Rotate left Port 1 - RotNo times
//
//           Function parameter
//           ==================
//              RotNo - number of times to rotate port
*/
void RolP1(unsigned char RotNo)
{
  unsigned char RotCnt;
  for ( RotCnt = 1; RotCnt <= RotNo; RotCnt++ )
  {
     Delay();
     if (( RegP1 & 0x80 ) == 0x80 )
       RegP1 = (RegP1 << 1) | 1;
     else
       RegP1 = (RegP1 << 1);
  }
}

/*
//           Function : ROrP1
//           ==================
//           Rotate right Port 1 - RotNo times
//
//           Function parameter :
//              ROtNo - number of times to rotate port
*/
void RorP1(unsigned char RotNo)
{
  unsigned char RotCnt;
  for ( RotCnt = 1; RotCnt <= RotNo; RotCnt++ )
  {
     Delay();
     if (( RegP1 & 0x01 ) == 0x01 )
       RegP1 = (RegP1 >> 1) | 0x80;
     else
       RegP1 = (RegP1 >> 1);
  }
}

/*
//           Function : CplP1
//           ==================
//           Complement Port 1 - CplNo times
//
//           Function parameter
//              CplNo - number of times to complement port
*/
void CplP1(unsigned char CplNo)
{
  unsigned char CplCnt;
  for ( CplCnt = 1; CplCnt <= CplNo; CplCnt++ )
  {
     Delay();
     RegP1 = ~RegP1;
  }
}

/*
//           Function : main
//           ==================
//           Main block of program
*/
void main()
{
  init();
  while ( 1 )
  {
    Delay();
    RegP1 = PatternCPL;
    CplP1(8);
    Delay();
    RegP1 = PatternROR;
    RorP1(7);
    Delay();
    RegP1 = PatternROR;
    RorP1(7);
    Delay();
    RegP1 = PatternROL;
    RolP1(7);
    Delay();
    RegP1 = PatternROL;
    RolP1(7);
    Delay();
  }
}
